#include "BasicBlockWidget.hxx"

BasicBlockWidget::BasicBlockWidget(const QString& name, BasicBlock * block)
	: width(270), height(45)
	, name(name), block(block)
	, _proxy(this) {
	next[0] = NULL;	next[1] = NULL;
	_widget.setStyleSheet("QTableWidget { background-color : #ddddff; }");
	_widget.setSizeAdjustPolicy(QAbstractScrollArea::AdjustToContents);
	_widget.verticalHeader()->setDefaultSectionSize(18);
	_widget.setColumnCount(3);
	_widget.verticalHeader()->hide();
	_widget.horizontalHeader()->hide();
	_widget.setShowGrid(false);
	_widget.setWordWrap(false);
	_widget.setMinimumSize(210, 20);

	_proxy.setWidget(&_widget);
	_proxy.setPos(5, 20);

	if (width < 250) width = 250;
}

void BasicBlockWidget::addItem(uint8_t* bytes, size_t num_bytes,
                               QString line, const QString& href) {
	QString bytestring;

	for (size_t i(0); i < num_bytes; ++i) {
		const char * hexdigits = "0123456789ABCDEF";
		bytestring += hexdigits[(bytes[i] >> 4) & 0xF];
		bytestring += hexdigits[bytes[i] & 0xF];
		bytestring += ' ';
	}

	int current_row = _widget.rowCount();
	_widget.setRowCount(1 + current_row);
	_widget.setItem(current_row, 0, new QTableWidgetItem(bytestring));
	_widget.setItem(current_row, 1, new QTableWidgetItem(line.replace('\t', ' ')));
//	_widget.setItem(current_row, 2, new QTableWidgetItem(href));

	_widget.resizeColumnToContents(0);
	_widget.resizeColumnToContents(1);
	_widget.resizeColumnToContents(2);

	width = 12 + _widget.sizeHint().width();
	height = 25 + _widget.sizeHint().height();

	if (width < 250) width = 250;
	_widget.resize(width - 12, height - 25);
}
